<script setup>
import { onMounted, toRef, watch } from 'vue';
import { useField } from 'vee-validate';
import { BFormInput } from 'bootstrap-vue';
import vSelect from "vue-select";
import { BRow, BCol } from 'bootstrap-vue';
import countrycode from '@/countrycode.json'
const props = defineProps({
  type: {
    type: String,
    default: 'text',
  },
  value: {
    type: String,
    default: undefined,
  },
  valueCode: {
    type: String,
    default: undefined,
  },
  disabled: {
    type: Boolean,
    default: null,
  },
  autofocus: {
    type: Boolean,
    default: false,
  },
  name: {
    type: String,
    required: true,
  },
  nameCode: {
    type: String,
    required: true,
  },
  maxlength: {
    type: Number,
    default: 1000000,
  },
  label: {
    type: String,
    required: true,
  },
  successMessage: {
    type: String,
    default: '',
  },
  placeholder: {
    type: String,
    default: '',
  },
  options: {
    type: Object,
    default: [],
  },
});

// use `toRef` to create reactive references to `name` prop which is passed to `useField`
// this is important because vee-validte needs to know if the field name changes
// https://vee-validate.logaretm.com/v4/guide/composition-api/caveats
const name = toRef(props, 'name');
const value = toRef(props, 'value');
const nameCode = toRef(props, 'nameCode');
const valueCode = toRef(props, 'valueCode');
const options = toRef(props, 'options');

watch([value], () => {
  if (value.value) {
    setValue(value.value);
  } else {
    resetField({
      value: '',
      touched: false,
      errors: []
    })
  }
})
watch([valueCode],()=>{
  if (valueCode.value) {
    checkCoutryCode(valueCode)
  }    
})

// we don't provide any rules here because we are using form-level validation
// https://vee-validate.logaretm.com/v4/guide/validation#form-level-validation
const {value: contryCodeValue, setValue: codeSetValue} = useField(nameCode, undefined, {
  initialValue: props.valueCode,
});
const {
  value: inputValue,
  errorMessage,
  handleBlur,
  handleChange,
  setState,
  resetField,
  setValue,
  meta,
} = useField(name, undefined, {
  initialValue: props.value,
});

let valueSelected = props.valueCode;
const countryCodeValidation = { minLength: 10, maxLength: 10 };
const emit = defineEmits(['validationUpdate', 'change'])
const  checkCoutryCode = (value) => {
  codeSetValue(value.value);
  const result = countrycode.filter(element => element.dial_code === value?.value);
  const countryCodeValue = result[0];
  if (countryCodeValue) {
    countryCodeValidation.minLength = countryCodeValue.minLength;
    countryCodeValidation.maxLength = countryCodeValue.maxLength;
  }
  emit('validationUpdate', countryCodeValidation)
  // codeField.
}
const isNumber = (e) => {
  let char = String.fromCharCode(e.keyCode); // Get the character
  if (/^[0-9]+$/.test(char)) return true;
  // Match with regex
  else e.preventDefault(); // If not match, don't add to input text
}
const changedValue = (ev) => {
    emit('change', ev)
}

</script>

<template>
  <div class="ContactInput" :class="{ 'has-error': !!errorMessage, success: meta.valid }">
    <label class="d-block" for="phone_number">{{ label }} <span
                            class="text-danger">*</span></label>
    <b-row>
      <b-col cols="12" md="4">
        <v-select class="eb-select" :disabled="disabled"
          :modelValue="contryCodeValue" 
          :options="options" 
          :name="nameCode"
          :id="nameCode"
          :reduce="(val) => val.value"
          :clearable="false" 
          @option:selected="(val) => checkCoutryCode(val)" />
      </b-col>
      <b-col cols="12" md="8">
        <b-form-input 
        :disabled="disabled"
        :id="name"
        :name="name"
        :value="value"
        :maxlength="countryCodeValidation.maxLength"
        :state="errorMessage ? false : null"
        :placeholder="placeholder"
        @input="handleChange"
        @blur="handleBlur"
        @change="changedValue"
        v-on:keypress="isNumber($event)" />
        <small class="text-danger" v-if="errorMessage">{{ errorMessage }}</small>
      </b-col>
    </b-row>

  </div>
</template>

<style scoped>
/* .has-error .form-control {
  background-image: url("data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' width='12' height='12' fill='none' stroke='red'%3E%3Ccircle cx='6' cy='6' r='4.5'/%3E%3Cpath stroke-linejoin='round' d='M5.8 3.6h.4L6 6.5z'/%3E%3Ccircle cx='6' cy='8.2' r='.6' fill='%23a4c008' stroke='none'/%3E%3C/svg%3E") !important;
  background-repeat: no-repeat;
  background-size: calc(.725em + .438rem) calc(.725em + .438rem)
}
.has-error .form-control:focus {
  background-image: url("data:image/svg+xml;charset=utf-8,%3Csvg xmlns='http://www.w3.org/2000/svg' width='12' height='12' fill='none' stroke='red'%3E%3Ccircle cx='6' cy='6' r='4.5'/%3E%3Cpath stroke-linejoin='round' d='M5.8 3.6h.4L6 6.5z'/%3E%3Ccircle cx='6' cy='8.2' r='.6' fill='%23a4c008' stroke='none'/%3E%3C/svg%3E");
  background-repeat: no-repeat;
  background-size: calc(.725em + .438rem) calc(.725em + .438rem)
} */
</style>
